<!--
  - Copyright (C) 2021-2023 The Hunter2 Contributors.
  -
  - This file is part of Hunter2.
  -
  - Hunter2 is free software: you can redistribute it and/or modify it under the terms of the GNU Affero General Public License as published by the Free
  - Software Foundation, either version 3 of the License, or (at your option) any later version.
  -
  - Hunter2 is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
  - PARTICULAR PURPOSE.  See the GNU Affero General Public License for more details.
  -
  - You should have received a copy of the GNU Affero General Public License along with Hunter2.  If not, see <http://www.gnu.org/licenses/>.
  -->
<template>
  <div>
    <h3>Clues</h3>
    <p v-if="none">
      <em>None yet</em>
    </p>
    <transition-group
      id="hints"
      name="highlight"
      tag="ul"
    >
      <li
        v-for="[id, hint] in sortedHints"
        :key="id"
        :class="hint.isNew ? 'newClue' : 'oldClue'"
      >
        <span class="hint-time">{{ durationString(hint.time) }}: </span>
        <span
          v-if="hint.obsolete"
          class="obsolete"
        >
          (<span
            class="hover"
            title="You entered a guess which indicated you don't need this hint"
          >surpassed</span>)
        </span>
        <!-- eslint-disable vue/no-v-html -- Hint text is admin generated content -->
        <strong
          v-if="hint.accepted"
          :class="{ obsolete: hint.obsolete }"
          v-html="hint.hint"
        />
        <!-- eslint-enable vue/no-v-html -->
        <a
          v-else
          href="#"
          :class="{ obsolete: hint.obsolete }"
          @click.prevent="acceptHint(id, null)"
        >show</a>
      </li>
    </transition-group>
    <table
      v-if="clueData.unlocks.size > 0"
      id="unlocks"
    >
      <thead>
        <tr class="unlock">
          <th class="unlock-guesses">
            Guesses
          </th>
          <th class="unlock-clues">
            Clues
          </th>
        </tr>
      </thead>
      <tbody>
        <tr
          v-for="([id, unlock], index) in sortedUnlocks"
          :key="id"
          class="unlock"
        >
          <td>
            <transition-group
              :id="`unlock-${id}-guesses`"
              name="highlight"
              tag="ul"
              class="unlock-guesses"
              appear
            >
              <li
                v-for="ua in unlock.guesses"
                :key="ua"
                :title="ua"
                :class="unlock.isNew ? 'newClue' : 'oldClue'"
              >
                <strong>{{ ua }}</strong>
              </li>
            </transition-group>
          </td>
          <td>
            <transition-group
              :id="`unlock-${id}-hints`"
              name="highlight"
              tag="ul"
              class="unlock-clues"
              appear
            >
              <!-- eslint-disable vue/no-v-html -- Unlock text is admin generated content -->
              <li
                v-if="unlock.unlock"
                class="unlock-text"
                v-html="unlock.unlock"
              />
              <!-- eslint-enable vue/no-v-html -->
              <li
                v-for="[hintID, hint] in unlock.hints"
                :key="hintID"
                :class="hint.isNew ? 'newClue' : 'oldClue'"
              >
                <span
                  v-if="hint.obsolete"
                  class="obsolete"
                >
                  (<span
                    class="hover"
                    title="You entered a guess which indicated you don't need this hint"
                  >surpassed</span>)
                </span>
                <!-- eslint-disable vue/no-v-html -- Hint text is admin generated content -->
                <strong
                  v-if="hint.accepted"
                  :class="{ obsolete: hint.obsolete }"
                  v-html="hint.hint"
                />
                <!-- eslint-enable vue/no-v-html -->
                <a
                  v-else
                  href="#"
                  @click.prevent="acceptHint(hintID, id)"
                >show</a>
                <span class="hint-time"> (after {{ durationString(hint.time) }})</span>
              </li>
            </transition-group>
          </td>
          <div
            v-if="index != sortedUnlocks.length - 1"
            class="unlock-divider"
          />
        </tr>
      </tbody>
    </table>
  </div>
</template>
<script>
import Cookies from 'js-cookie'
import {Duration} from 'luxon'
import * as Sentry from '@sentry/browser'

import {fadingMessage} from './puzzle'

export default {
  props: {
    clueData: {
      required: true,
      type: Object,
    },
  },
  computed: {
    none() {
      return this.clueData.hints.size === 0 && this.clueData.unlocks.size === 0 ? 'None yet' : ''
    },
    sortedHints() {
      return this.hintArray(this.clueData.hints)
    },
    sortedUnlocks() {
      const t = this
      let ordered = []
      let failures = []
      for (const id of t.clueData.unlockOrder) {
        if (t.clueData.unlocks.has(id)) {
          const u = t.clueData.unlocks.get(id)
          ordered.push([id, {
            unlock: u.unlock,
            guesses: u.guesses,
            isNew: u.isNew,
            hints: t.hintArray(u.hints),
          }])
        } else {
          failures.push(id)
        }
      }
      if (failures.length > 0) {
        Sentry.withScope(function(scope) {
          scope.setExtras({
            order: t.clueData.unlockOrder,
            unlocks: Object.fromEntries(t.clueData.unlocks),
          })
          Sentry.captureMessage('Unlocks in order not present')
        })
      }
      return ordered
    },
  },
  methods: {
    durationString(value) {
      return Duration.fromISO(value).toFormat('hh:mm:ss')
    },
    hintArray(hintMap) {
      return Array.from(
        hintMap.entries(),
      ).sort(
        (a, b) => (a[1].time.localeCompare(b[1].time)),
      )
    },
    acceptHint(hintId, unlockId) {
      fetch(
        'accept_hint',
        {
          method: 'POST',
          body: new URLSearchParams({
            id: hintId.toString(),
          }),
          headers: {
            'X-CSRFToken': Cookies.get('csrftoken'),
          },
        },
      ).then(
        res => res.json(),
      ).then(
        data => {
          if ('error' in data) {
            console.log('Server returned error when trying to accept the hint.', data.error)
            fadingMessage(
              document.querySelector('#hints'),
              'Server returned error when trying to accept the hint.',
              data.error,
            )
            return
          }
          let hintData
          if (unlockId === null) {
            hintData = this.clueData.hints.get(hintId)
          } else {
            hintData = this.clueData.unlocks.get(unlockId).hints.get(hintId)
          }
          // if the response arrives before the websocket message, display a holding message
          if (!hintData.accepted) {
            hintData.accepted = true
            hintData.hint = '<i>getting hint...</i>'
          }
        },
      ).catch(
        err => {
          console.log('There was an error accepting the hint.', err)
          fadingMessage(document.querySelector('#hints'), 'There was an error accepting the hint.', err)
        },
      )
    },
  },
}
</script>
<style lang="scss" scoped>
ul {
    list-style: none;
    padding: 0;
    margin: 0;
}

li {
    margin-top: 3pt;
    margin-bottom: 3pt;
}

#hints {
    margin: 1em;
}

#unlocks {
    margin: 1em;
    display: inline-grid;
    grid-template-columns: minmax(100px, 1fr) minmax(100px, 2fr);
    grid-gap: 1em;
    align-items: center;

    .unlock-divider {
        grid-column: 1 / 3;
        border-top: 1px dotted #ffffff33;
    }
    thead, tbody {
      display: contents;
    }
    .unlock {
        display: contents;
        th {
            opacity: 50%;
        }
        .unlock-guesses {
            grid-column: 1;
            text-align: right;
            li {
                white-space: nowrap;
                text-overflow: ellipsis;
                overflow: hidden;
                text-align: right;
            }
        }
        .unlock-clues {
            grid-column: 2;
            .hint-time {
                font-style: italic;
            }
        }
    }
}

.hint-time {
    opacity: 60%;
}

#unlocks > li {
    font-style: italic;
    > * {
        font-style: normal;
    }
}

.obsolete {
    opacity: 33%;
    > a {
        opacity: 50%;
    }
}

.highlight-enter-from.newClue {
    background-color: yellow;
}

.highlight-enter-active.newClue {
    transition: background-color 5s;
}

.hover {
    text-decoration: underline dotted;
    cursor: help;
}
</style>
